package cn.iocoder.yudao.module.pms.service.qhse.ptw;

import cn.iocoder.yudao.framework.common.exception.ErrorCode;
import cn.iocoder.yudao.framework.common.exception.ServiceException;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.common.util.object.BeanUtils;
import cn.iocoder.yudao.framework.security.core.util.SecurityFrameworkUtils;
import cn.iocoder.yudao.module.pms.controller.admin.qhse.ptw.vo.QhsePtwPageReqVO;
import cn.iocoder.yudao.module.pms.controller.admin.qhse.ptw.vo.QhsePtwSaveReqVO;
import cn.iocoder.yudao.module.pms.controller.admin.stat.DeptUtil;
import cn.iocoder.yudao.module.pms.dal.dataobject.qhse.ptw.QhsePtwDO;
import cn.iocoder.yudao.module.pms.dal.mysql.qhse.ptw.QhsePtwMapper;
import cn.iocoder.yudao.module.pms.service.qhse.ChineseLetterUtil;
import cn.iocoder.yudao.module.pms.service.qhse.jsa.QhseJsaService;
import cn.iocoder.yudao.module.system.api.dept.DeptApi;
import cn.iocoder.yudao.module.system.api.dept.dto.DeptRespDTO;
import cn.iocoder.yudao.module.system.service.dept.DeptService;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.validation.annotation.Validated;

import javax.annotation.Resource;

import java.util.HashSet;
import java.util.Objects;
import java.util.Set;

import static cn.iocoder.yudao.framework.common.exception.util.ServiceExceptionUtil.exception;

/**
 * QHSE_PTW作业许可 Service 实现类
 *
 * @author 超级管理员
 */
@Service
@Validated
public class QhsePtwServiceImpl implements QhsePtwService {

    @Resource
    private QhsePtwMapper qhsePtwMapper;
    @Autowired
    private DeptApi deptApi;
    @Autowired
    private DeptUtil deptUtil;
    @Autowired
    private QhseJsaService qhseJsaService;
    @Autowired
    private DeptService deptService;

    @Override
    public Long createQhsePtw(QhsePtwSaveReqVO createReqVO) {
        // 插入
        QhsePtwDO qhsePtw = BeanUtils.toBean(createReqVO, QhsePtwDO.class);
        qhsePtw.setDeleted(false);

        Long loginUserDeptId;
        if (createReqVO.getDeptId() != null) {
            loginUserDeptId = createReqVO.getDeptId();
        }else {
            loginUserDeptId = SecurityFrameworkUtils.getLoginUserDeptId();
        }
        if (Objects.nonNull(loginUserDeptId)) {
            DeptRespDTO dept = deptApi.getDept(loginUserDeptId);
            if (Objects.nonNull(dept)) {
                qhsePtw.setDeptName(dept.getName());
                //获取队伍代码大写
                String convert = ChineseLetterUtil.convert(dept.getName());
                //获取公司代码大写
                String company = deptUtil.getCompanyCode(loginUserDeptId).toUpperCase();
                //获取项目部代码大写
                String jsaNo = qhseJsaService.getJSANo(loginUserDeptId);
                if (StringUtils.isBlank(jsaNo)){throw new ServiceException(new ErrorCode(2,"获取项目部编号失败"));}
                qhsePtw.setPtwNo(company+"-"+jsaNo+"-"+convert);
            }
        }

        qhsePtwMapper.insert(qhsePtw);
        // 返回
        return qhsePtw.getId();
    }

    @Override
    public void updateQhsePtw(QhsePtwSaveReqVO updateReqVO) {
        // 校验存在
        validateQhsePtwExists(updateReqVO.getId());
        // 更新
        QhsePtwDO updateObj = BeanUtils.toBean(updateReqVO, QhsePtwDO.class);
        qhsePtwMapper.updateById(updateObj);
    }

    @Override
    public void deleteQhsePtw(Long id) {
        // 校验存在
        validateQhsePtwExists(id);
        // 删除
        qhsePtwMapper.deleteById(id);
    }

    private void validateQhsePtwExists(Long id) {
        if (qhsePtwMapper.selectById(id) == null) {
            throw exception(new ErrorCode(1,"不存在"));
        }
    }

    @Override
    public QhsePtwDO getQhsePtw(Long id) {
        return qhsePtwMapper.selectById(id);
    }

    @Override
    public PageResult<QhsePtwDO> getQhsePtwPage(QhsePtwPageReqVO pageReqVO) {
        Set<Long> ids = new HashSet<>();
        if (Objects.nonNull(pageReqVO.getDeptId())) {
            ids = deptService.getChildDeptIdListFromCache(pageReqVO.getDeptId());
            ids.add(pageReqVO.getDeptId());
        }
        return qhsePtwMapper.selectPage(pageReqVO, ids);
    }

}